| OpendTect 8.0

Loading...
Searching...
No Matches
Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
WaveletExtractor Class Reference
Seis

`#include <waveletextractor.h>`

Inheritance diagram for WaveletExtractor:
[legend]

## Public Member Functions
| WaveletExtractor (const IOObj &, int wvltsize)
| ~WaveletExtractor ()
const Wavelet & | getWavelet () const
void | setPhase (int phase)
void | setSelData (const ObjectSet< Seis::SelData > &)
void | setSelData (const Seis::SelData &)
void | setTaperParamVal (float paramval)
Public Member Functions inherited from Executor
| Executor (const char *nm)
virtual | ~Executor ()
int | doStep () override
bool | execute () override
bool | go (od_ostream &s, bool isfirst=true, bool islast=true, int delaybtwnstepsinms=0)
bool | go (od_ostream *s=0, bool isfirst=true, bool islast=true, int delaybtwnstepsinms=0)
Public Member Functions inherited from SequentialTask
| SequentialTask (const char *nm=nullptr)
virtual | ~SequentialTask ()
bool | execute () override
Public Member Functions inherited from ReportingTask
| ReportingTask (const ReportingTask &)=delete
virtual | ~ReportingTask ()
void | getProgress (const ReportingTask &)
ReportingTask & | operator= (const ReportingTask &)=delete
void | setSimpleMeter (bool yn, int repperc)
int | simpleMeterStep () const
bool | useSimpleMeter () const
Public Member Functions inherited from Task
| Task (const Task &)=delete
virtual | ~Task ()
virtual void | controlWork (Control)
virtual void | enableWorkControl (bool=true)
| Must be called before execute()
virtual uiRetVal | errorWithDetails () const
virtual Control | getState () const
Task & | operator= (const Task &)=delete
bool | workControlEnabled () const
Public Member Functions inherited from NamedCallBacker
| NamedCallBacker (const char *nm=nullptr)
| NamedCallBacker (const NamedCallBacker &)=delete
| ~NamedCallBacker ()
virtual Notifier< NamedCallBacker > & | objectToBeDeleted () const
NamedCallBacker & | operator= (const NamedCallBacker &)=delete
bool | operator== (const NamedCallBacker &oth) const
bool | operator== (const NamedObject &oth) const
Public Member Functions inherited from CallBacker
| CallBacker ()
| CallBacker (const CallBacker &)
virtual | ~CallBacker ()
bool | attachCB (const NotifierAccess &, const CallBack &, bool onlyifnew=false) const
bool | attachCB (const NotifierAccess *notif, const CallBack &cb, bool onlyifnew=false) const
void | detachAllNotifiers () const
| Call from the destructor of your inherited object.
void | detachCB (const NotifierAccess &, const CallBack &) const
void | detachCB (const NotifierAccess *notif, const CallBack &cb) const
virtual bool | isCapsule () const
bool | isNotifierAttached (const NotifierAccess *) const
| Only for debugging purposes, don't use.
CallBacker & | operator= (const CallBacker &)=delete
void | stopReceivingNotifications () const
virtual CallBacker * | trueCaller ()
Public Member Functions inherited from NamedObject
| NamedObject (const char *nm=nullptr)
| NamedObject (const NamedObject &oth)
virtual | ~NamedObject ()
virtual BufferString | getName () const
bool | getNameFromPar (const IOPar &)
const name_type & | name () const override
NamedObject & | operator= (const NamedObject &)
bool | operator== (const NamedObject &oth) const
virtual void | setName (const char *nm)
Public Member Functions inherited from ObjectWithName
virtual | ~ObjectWithName ()
bool | hasName (const char *nm) const
bool | hasName (const name_type &nm) const
void | putNameInPar (IOPar &) const

## Protected Member Functions
bool | doWaveletIFFT ()
bool | finish (int nrusedtrcs)
bool | getNextLine ()
bool | getSignalInfo (const SeisTrc &, int &start, int &signalsz) const
void | init2D ()
void | init3D ()
void | initWavelet (const IOObj &)
int | nextStep () override
void | normalisation (Array1DImpl< float > &arr)
void | normalization (Array1DImpl< float > &)
od_int64 | nrDone () const override
bool | processTrace (const SeisTrc &, int start, int signalsz)
bool | rotateWavelet ()
bool | taperWavelet ()
od_int64 | totalNr () const override
uiString | uiMessage () const override
uiString | uiNrDoneText () const override
Protected Member Functions inherited from Executor
virtual bool | goImpl (od_ostream *, bool, bool, int)
Protected Member Functions inherited from SequentialTask
virtual bool | doFinish (bool success, od_ostream *=nullptr)
virtual bool | doPrepare (od_ostream *=nullptr)
Protected Member Functions inherited from ReportingTask
| ReportingTask (const char *nm=nullptr)
void | incrementProgress ()
ProgressMeter * | progressMeter () const
void | reportProgressFinished ()
void | reportProgressStarted ()
void | resetProgress ()
void | setProgressMeter (ProgressMeter *) override
| Must be called before execute()
void | updateProgressMeter (bool forced=false, od_int64 *totalnr=0)
void | updateReportedName ()
Protected Member Functions inherited from Task
| Task (const char *nm=nullptr)
virtual bool | shouldContinue ()
Protected Member Functions inherited from NamedCallBacker
void | sendDelNotif () const

## Protected Attributes
Fourier::CC * | fft_
const IOObj & | iobj_
bool | isbetweenhor_
int | lineidx_
uiString | msg_
int | nrdone_
int | nrusedtrcs_
float | paramval_
int | phase_
const Seis::SelData * | sd_ = nullptr
ObjectSet< Seis::SelData > | sdset_
SeisTrcReader * | seisrdr_ = nullptr
od_int64 | totalnr_
Wavelet & | wvlt_
int | wvltsize_
Protected Attributes inherited from Task
Control | control_ = Task::Run
Threads::ConditionVar * | workcontrolcondvar_ = nullptr
Protected Attributes inherited from NamedCallBacker
Threads::Atomic< bool > | delalreadytriggered_
Notifier< NamedCallBacker > | delnotif_
Protected Attributes inherited from NamedObject
BufferString | name_

## Additional Inherited Members
Public Types inherited from Task
enum | Control { Run , Pause , Stop }
Public Types inherited from ObjectWithName
typedef OD::String | name_type
Static Public Member Functions inherited from SequentialTask
static int | ErrorOccurred ()
static int | Finished ()
static int | MoreToDo ()
static int | WarningAvailable ()
Static Public Member Functions inherited from ReportingTask
static PtrMan< ProgressMeter > | getTextProgressMeter (od_ostream &, const IOPar *iop=nullptr)
static bool | needSimpleLogging (const IOPar &)
static const char * | sKeySimpleLogging ()
static const char * | sKeySimpleLoggingStep ()
Static Public Member Functions inherited from Task
static uiString | uiStdNrDoneText ()
Static Public Member Functions inherited from CallBacker
static void | createReceiverForCurrentThread ()
static void | removeReceiverForCurrentThread ()
Public Attributes inherited from Executor
Notifier< Executor > | poststep
| Only when MoreToDo will be returned.
Notifier< Executor > | prestep
Public Attributes inherited from ReportingTask
Notifier< ReportingTask > | progressUpdated

## Detailed Description

<>

## Constructor & Destructor Documentation

## ◆ WaveletExtractor()

WaveletExtractor::WaveletExtractor | ( | const IOObj & | ,
|  | int | wvltsize )

## ◆ ~WaveletExtractor()

WaveletExtractor::~WaveletExtractor | ( |  | ) |

## Member Function Documentation

## ◆ doWaveletIFFT()

bool WaveletExtractor::doWaveletIFFT | ( |  | ) |
| protected

## ◆ finish()

bool WaveletExtractor::finish | ( | int | nrusedtrcs | ) |
| protected

## ◆ getNextLine()

bool WaveletExtractor::getNextLine | ( |  | ) |
| protected

## ◆ getSignalInfo()

bool WaveletExtractor::getSignalInfo | ( | const SeisTrc & | ,
|  | int & | start,
|  | int & | signalsz ) const
| protected

## ◆ getWavelet()

const Wavelet & WaveletExtractor::getWavelet | ( |  | ) | const

## ◆ init2D()

void WaveletExtractor::init2D | ( |  | ) |
| protected

## ◆ init3D()

void WaveletExtractor::init3D | ( |  | ) |
| protected

## ◆ initWavelet()

void WaveletExtractor::initWavelet | ( | const IOObj & |  | ) |
| protected

## ◆ nextStep()

int WaveletExtractor::nextStep | ( |  | ) |
| override protected virtual

Return values

  MoreToDo() | Not finished. Call me again.
  Finished() | Nothing more to do.
  ErrorOccurred() | Something went wrong.

Note
  if function returns a value greater than cMoreToDo(), it should be interpreted as cMoreToDo().

Implements SequentialTask.

## ◆ normalisation()

void WaveletExtractor::normalisation | ( | Array1DImpl< float > & | arr | ) |
| inline protected

## ◆ normalization()

void WaveletExtractor::normalization | ( | Array1DImpl< float > & |  | ) |
| protected

## ◆ nrDone()

od_int64 WaveletExtractor::nrDone | ( |  | ) | const
| inline override protected virtual

Note
  nrDone is only used for displaying progress and will be compared to totalNr to show user how large part of the task that is finished.

Reimplemented from Task.

## ◆ processTrace()

bool WaveletExtractor::processTrace | ( | const SeisTrc & | ,
|  | int | start,
|  | int | signalsz )
| protected

## ◆ rotateWavelet()

bool WaveletExtractor::rotateWavelet | ( |  | ) |
| protected

## ◆ setPhase()

void WaveletExtractor::setPhase | ( | int | phase | ) |

## ◆ setSelData() [1/2]

void WaveletExtractor::setSelData | ( | const ObjectSet< Seis::SelData > & |  | ) |

## ◆ setSelData() [2/2]

void WaveletExtractor::setSelData | ( | const Seis::SelData & |  | ) |

## ◆ setTaperParamVal()

void WaveletExtractor::setTaperParamVal | ( | float | paramval | ) |

## ◆ taperWavelet()

bool WaveletExtractor::taperWavelet | ( |  | ) |
| protected

## ◆ totalNr()

od_int64 WaveletExtractor::totalNr | ( |  | ) | const
| inline override protected virtual

Reimplemented from Task.

## ◆ uiMessage()

uiString WaveletExtractor::uiMessage | ( |  | ) | const
| override protected virtual

Reimplemented from Task.

## ◆ uiNrDoneText()

uiString WaveletExtractor::uiNrDoneText | ( |  | ) | const
| override protected virtual

Reimplemented from Task.

## Member Data Documentation

## ◆ fft_

Fourier::CC* WaveletExtractor::fft_
| protected

## ◆ iobj_

const IOObj& WaveletExtractor::iobj_
| protected

## ◆ isbetweenhor_

bool WaveletExtractor::isbetweenhor_
| protected

## ◆ lineidx_

int WaveletExtractor::lineidx_
| protected

## ◆ msg_

uiString WaveletExtractor::msg_
| protected

## ◆ nrdone_

int WaveletExtractor::nrdone_
| protected

## ◆ nrusedtrcs_

int WaveletExtractor::nrusedtrcs_
| protected

## ◆ paramval_

float WaveletExtractor::paramval_
| protected

## ◆ phase_

int WaveletExtractor::phase_
| protected

## ◆ sd_

const Seis::SelData* WaveletExtractor::sd_ = nullptr
| protected

## ◆ sdset_

ObjectSet<Seis::SelData> WaveletExtractor::sdset_
| protected

## ◆ seisrdr_

SeisTrcReader* WaveletExtractor::seisrdr_ = nullptr
| protected

## ◆ totalnr_

od_int64 WaveletExtractor::totalnr_
| protected

## ◆ wvlt_

Wavelet& WaveletExtractor::wvlt_
| protected

## ◆ wvltsize_

int WaveletExtractor::wvltsize_
| protected

Generated at
for the OpendTect seismic interpretation project. Copyright (C): dGB Beheer B.V. 1995-2025